<?php

namespace Modules\Cadastros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class ParticularidadesReportController extends \Zeedhi\Framework\Controller\Report
{
    protected $qr2Strategy;
    protected $stNomeRel;    

    public function __construct(ReportService $reportService, $qr2Strategy)
    {
        parent::__construct($reportService);
        $this->qr2Strategy = $qr2Strategy;
    }

    protected $reportMapping = array();

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);

        $this->reportMapping[$this->stNomeRel] =
            array(
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                array(
                    'PRODINI'       => 'P_PRODINI',
                    'NMPRODINI'     => 'P_NMPRODINI',
                    'NMPRODFIN'     => 'P_NMPRODFIN',
                    'PRODFIN'       => 'P_PRODFIN',
                    'CDFILIAL'      => 'L_CDFILIAL',
                    'CDGRUPFILI'    => 'P_CDGRUPFILI',
                    'CDMARCA'       => 'L_CDMARCA',
                    'CDFORNECED'    => 'L_CDFORNECED',
                    'EXCLUI'        => 'P_EXCLUI',
                    'CDPRODINI'     => 'P_CDPRODINI',
                    'CDPRODFIN'     => 'P_CDPRODFIN',
                    'CDTIPPART'     => 'P_CDTIPPART',
                    'CDOPERADOR'    => 'P_CDOPERADOR',
                    'PRODPREF'      => 'P_PRODPREF',
                ),
            );
    }
}
