<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigEventom extends Base\MigEventom
{

    /**
     * @param $nreventom
     * @return \Folha\Entities\MigEventom
     */
    public function setNreventom ($nreventom) {
        $nreventom = \Importacao\Logic\Validacoes::verificaChaveDuplicada('FPA_EVENTOM', 'NREVENTOM', ProjetoImportacao::getNrorg(), $nreventom);
        $this->nreventom = $nreventom;
    }

    /**
     * @param mixed $dtfimvigencia
     * @return \Folha\Entities\GpeOcupacaom|void
     */
    public function setDtfimvigencia($dtfimvigencia)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtfimvigencia)) {
            if (!empty($dtfimvigencia)) {
                throw new \Exception("Fim de Vigência: Data '$dtfimvigencia' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtfimvigencia instanceof \DateTime)) {
            $dtfimvigencia = DateUtil::getDataDeString($dtfimvigencia);
        }

        $this->dtfimvigencia = $dtfimvigencia;
    }

    /**
     * @param mixed $dtinivigencia
     * @return \Folha\Entities\GpeOcupacaom|void
     */
    public function setDtinivigencia($dtinivigencia)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinivigencia)) {
            throw new \Exception("Campo Obrigatório - Início Vigência: Data '$dtinivigencia' com formato inválido ou em branco.");
        }

        if (!($dtinivigencia instanceof \DateTime)) {
            $dtinivigencia = DateUtil::getDataDeString($dtinivigencia);
        }

        $this->dtinivigencia = $dtinivigencia;
    }

    /**
     * @param mixed $dtinclusao
     * @return \Folha\Entities\GpeOcupacaom|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @return \Folha\Entities\GpeOcupacaom|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

}