<?php
	namespace Geral\Logic\Cadastros\Operador;
	use \Geral\Entities\Organizacaooper;
	use \Geral\Entities\Estruturaoper;
	use \Geral\Util\DateUtil;
	use \Geral\Util\NovoCodigo;
	use \Geral\Util\Ambiente;

	class OperadorOrganizacao{

		public function organizOper($operador, $organizacao){

			$orgOper = new Organizacaooper();

			$orgOper->setDtinclusao(DateUtil::getDataAtual());
			$orgOper->setNrorganizacaooper(NovoCodigo::geraCodigo(1,'ORGANIZACAOOPER', 1,22, true));
			$orgOper->setCdoperador($operador);
			$orgOper->SetNrorgrel($organizacao);
			$orgOper->setNrorginclusao(Ambiente::getNrorgTrabalho());

			$orgOper->persist();

			return ($orgOper);
		}

		/**
		 *@var $organizOper \Geral\Entities\Organizacaooper
		 */
		public function estrutOper($orgOper, $estrutura){
			
			$estrOper = new Estruturaoper();

			$estrOper -> setNrestruturamrel($estrutura);
			$estrOper -> setNrestruturaoper(NovoCodigo::geraCodigo(1,'ESTRUTURAOPER', 1,22, true));
			$estrOper -> setDtinclusao(DateUtil::getDataAtual());
			$estrOper -> setOrganizacaooper($orgOper);

			$estrOper->persist();
			
			return ($estrOper);
		}

		public function __construct($operador, $organizacao, $estrutura){
			
			if(!empty($operador) && !empty($organizacao)){
				$conn = \Setforms2\Shared\Registry::getEntityManager();

				$orgOper = $this->searchOrgOper($operador, $organizacao);

				if(!empty($estrutura) && !empty($orgOper)){
					
					if($this->searchEstrOper($orgOper, $estrutura)){
						return false;
						
					}else{
							$estrOper = $this->estrutOper($orgOper, $estrutura);
					}

				}else{
					$orgOper  = $this->organizOper($operador, $organizacao);
					// if(!empty($estrutura) && !empty($orgOper)){
					// 	$estrOper = $this->estrutOper($orgOper, $estrutura);
					// }
					tk_var_dump($orgOper);

				}

				$conn->flush();
				return true;
			}
		}

		private function searchOrgOper($operador, $organizacao){

			$object = Organizacaooper::getObjectByWhere('NRORGREL = ? AND CDOPERADOR = ?', array($organizacao, $operador));
			tk_var_dump($object);
			
			if($object){
				return $object->getNrorganizacaooper();
			}else{
				return false;
			}
		}

		private function searchEstrOper($orgOper, $estrutura){
			$object = Estruturaoper::getObjectByWhere('NRORGANIZACAOOPER = ? AND NRESTRUTURAMREL = ?', array($orgOper, $estrutura));
			tk_var_dump($object);

			if($object){
				return true;
			}else{
				return false;
			}
		}
		
	}