<?php

require_once 'base/FpaValorreferenciamEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author  alessandrobartels
 */
class FpaValorreferenciamEntity extends FpaValorreferenciamEntityBase
{

    const SALARIO_MINIMO = 'SALARIO_MINIMO';
    const FGTS = 'FGTS';
    const FGTS_RESC_MULTA = 'FGTS_RESC_MULTA';
    const VR_DEDUCAO_DEP_IR = 'VR_DEDUCAO_DEP_IR';
    const VR_RECOLHIMENTO_MIN_IR = 'VR_RECOLHIMENTO_MIN_IR';
    const CONTRIB_SOC_RESC = 'CONTRIB_SOC_RESC';
    const PERCENTUAL_INSS_AUTONOMO = 'PERCENTUAL_INSS_AUTONOMO';

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;


    public function __construct($nrOrg, $nrOrgPadrao, $mesCompetencia){
        $this->_nrOrg = $nrOrg;
        $this->_nrOrgPadrao = $nrOrgPadrao;
        $this->_mesCompetencia = $mesCompetencia;
    }


    public function carregaValorReferencia(){

        $resultados = FpaValorreferenciam::retornaValorReferencia($this->_nrOrg, $this->_nrOrgPadrao);

        foreach ($resultados as $resultado) {

            $historico = FpaValorreferenciah::retornaValorReferenciaHistorico(
                $this->_mesCompetencia, $resultado->getNrvalorreferenciam()
            );

            $resultado->historico = $historico;

            $this->addItem($resultado, $resultado->getDsreferencia());
        }

    }


    public function getValorReferencia($referencia){

        $itens = $this->getItems();

        if (count($itens) === 0) {
            $this->carregaValorReferencia();
            $itens = $this->getItems();
        }
        //BORBA 19/04/2013
        if (count($itens) === 0) {
            tk_warning('Não carregou valores '.$referencia);
            return 0;
        } else{
            if (array_key_exists($referencia,$itens)){
                $item = $itens[$referencia];
                if(!is_object($item->historico)){

                    tk_warning('Não encontrou valor histórico para '.$referencia);
                    return 0;
                }
                else{
                    return $item->historico->getVrreferencia();
                }
            } else{
                if($referencia){
                    tk_warning('Não encontrou valor para '.$referencia);
                } else{
                    tk_warning('Tentativa de acessar valor de referência vazio');
                }
                return 0;
            }

        }

    }


    public function getReferencia($referencia){

        $itens = $this->getItems();

        if (count($itens) === 0) {
            $this->carregaValorReferencia();
            $itens = $this->getItems();
        }

        $item = $itens[$referencia];
        return $item->historico->getVrrefvalorref();
        //return $itens[$referencia];
    }


    public function getDescricaoReferencia($nrValorReferencia){
        $itens = $this->getItems();

        if (count($itens) === 0) {
            $this->carregaValorReferencia();
            $itens = $this->getItems();
        }

        foreach ($itens as $item){
            if ($item->getNrvalorreferenciam() === $nrValorReferencia){
                return $item->getDsreferencia();
            }
        }

    }

}

