/* Tabela cOMANDAFOS: TABELA DE MOVIMENTO DE CLIENTES */
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela MOVICLIE */
/* Objetivo: Gerar um log que vai registrar as alteraes na MOVICLIE,
             utilizando a tabela de Logs de Operaes do VND*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_MOVICLIE' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_MOVICLIE
GO


CREATE TRIGGER LOG_VND_MOVICLIE
ON MOVICLIE
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_CDCLIENTE	varchar(21);
  DECLARE @V_NEW_NRSEQMOVCLI	varchar(10);
  DECLARE @V_NEW_CDCONSUMIDOR	varchar(21);
  DECLARE @V_NEW_VRMOVCLI	decimal(17);
  DECLARE @V_NEW_DTMOVCLI	datetime;
  DECLARE @V_NEW_DSHISTMOV	varchar(80);
  DECLARE @V_NEW_IDTIPMOCVLI	varchar(1);
  DECLARE @V_NEW_CDFILIAL	varchar(4);
  DECLARE @V_NEW_CDCAIXA        varchar(3);
  DECLARE @V_NEW_NRSEQVENDA	varchar(10);
  DECLARE @V_NEW_DTABERCAIX	datetime;
  DECLARE @V_NEW_NRSEQUMOVI	varchar(10);
  DECLARE @V_NEW_CDTIPORECE	varchar(3);
  DECLARE @V_NEW_VRSALDOCONS	decimal(17);
  DECLARE @V_NEW_VRMOVPESCONS	decimal(17);
  DECLARE @V_NEW_VRSALDPECONS	decimal(17);
  DECLARE @V_NEW_CDOPERADOR	varchar(12);
  DECLARE @V_NEW_CDOPERECSALD	varchar(12);
  DECLARE @V_NEW_DTATUMOVCLIE	datetime;
  DECLARE @V_NEW_DSATUMOVCLIE	varchar(200);
  DECLARE @V_NEW_DTMOVIMCLIE	datetime;
  DECLARE @V_NEW_DTRECMOVCLIE	datetime;
  DECLARE @V_NEW_CDFILIAPFATU	varchar(4);
  DECLARE @V_NEW_NRAPURACFATU	varchar(10);
  DECLARE @V_NEW_VRPESUBSIDIO	decimal(17);
  DECLARE @V_NEW_VRTETOSUBSID	decimal(17);
  DECLARE @V_NEW_DTULTATUMCLI	datetime;

  DECLARE @V_OLD_CDCLIENTE	varchar(21);
  DECLARE @V_OLD_NRSEQMOVCLI	varchar(10);
  DECLARE @V_OLD_CDCONSUMIDOR	varchar(21);
  DECLARE @V_OLD_VRMOVCLI	decimal(17);
  DECLARE @V_OLD_DTMOVCLI	datetime;
  DECLARE @V_OLD_DSHISTMOV	varchar(80);
  DECLARE @V_OLD_IDTIPMOCVLI	varchar(1);
  DECLARE @V_OLD_CDFILIAL	varchar(4);
  DECLARE @V_OLD_CDCAIXA        varchar(3);
  DECLARE @V_OLD_NRSEQVENDA	varchar(10);
  DECLARE @V_OLD_DTABERCAIX	datetime;
  DECLARE @V_OLD_NRSEQUMOVI	varchar(10);
  DECLARE @V_OLD_CDTIPORECE	varchar(3);
  DECLARE @V_OLD_VRSALDOCONS	decimal(17);
  DECLARE @V_OLD_VRMOVPESCONS	decimal(17);
  DECLARE @V_OLD_VRSALDPECONS	decimal(17);
  DECLARE @V_OLD_CDOPERADOR	varchar(12);
  DECLARE @V_OLD_CDOPERECSALD	varchar(12);
  DECLARE @V_OLD_DTATUMOVCLIE	datetime;
  DECLARE @V_OLD_DSATUMOVCLIE	varchar(200);
  DECLARE @V_OLD_DTMOVIMCLIE	datetime;
  DECLARE @V_OLD_DTRECMOVCLIE	datetime;
  DECLARE @V_OLD_CDFILIAPFATU	varchar(4);
  DECLARE @V_OLD_NRAPURACFATU	varchar(10);
  DECLARE @V_OLD_VRPESUBSIDIO	decimal(17);
  DECLARE @V_OLD_VRTETOSUBSID	decimal(17);
  DECLARE @V_OLD_DTULTATUMCLI	datetime;

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;


   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           DELETED.CDCLIENTE,
           DELETED.NRSEQMOVCLI,
           DELETED.CDCONSUMIDOR,
           DELETED.VRMOVCLI,
           DELETED.DTMOVCLI,
           DELETED.DSHISTMOV,
           DELETED.IDTIPMOCVLI,
           DELETED.CDFILIAL,
           DELETED.CDCAIXA,
           DELETED.NRSEQVENDA,
           DELETED.DTABERCAIX,
           DELETED.NRSEQUMOVI,
           DELETED.CDTIPORECE,
           DELETED.VRSALDOCONS,
           DELETED.VRMOVPESCONS,
           DELETED.VRSALDPECONS,
           DELETED.CDOPERADOR,
           DELETED.CDOPERECSALD,
           DELETED.DTATUMOVCLIE,
           DELETED.DSATUMOVCLIE,
           DELETED.DTMOVIMCLIE,
           DELETED.DTRECMOVCLIE,
           DELETED.CDFILIAPFATU,
           DELETED.NRAPURACFATU,
           DELETED.VRPESUBSIDIO,
           DELETED.VRTETOSUBSID,
           DELETED.DTULTATUMCLI

     FROM
           DELETED
     WHERE     
           DELETED.CDFILIAL + DELETED.NRSEQMOVCLI     NOT IN (SELECT CDFILIAL + NRSEQMOVCLI FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,           
           INSERTED.CDCLIENTE,
           INSERTED.NRSEQMOVCLI,
           INSERTED.CDCONSUMIDOR,
           INSERTED.VRMOVCLI,
           INSERTED.DTMOVCLI,
           INSERTED.DSHISTMOV,
           INSERTED.IDTIPMOCVLI,
           INSERTED.CDFILIAL,
           INSERTED.CDCAIXA,
           INSERTED.NRSEQVENDA,
           INSERTED.DTABERCAIX,
           INSERTED.NRSEQUMOVI,
           INSERTED.CDTIPORECE,
           INSERTED.VRSALDOCONS,
           INSERTED.VRMOVPESCONS,
           INSERTED.VRSALDPECONS,
           INSERTED.CDOPERADOR,
           INSERTED.CDOPERECSALD,
           INSERTED.DTATUMOVCLIE,
           INSERTED.DSATUMOVCLIE,
           INSERTED.DTMOVIMCLIE,
           INSERTED.DTRECMOVCLIE,
           INSERTED.CDFILIAPFATU,
           INSERTED.NRAPURACFATU,
           INSERTED.VRPESUBSIDIO,
           INSERTED.VRTETOSUBSID,
           INSERTED.DTULTATUMCLI,

           DELETED.CDCLIENTE,
           DELETED.NRSEQMOVCLI,
           DELETED.CDCONSUMIDOR,
           DELETED.VRMOVCLI,
           DELETED.DTMOVCLI,
           DELETED.DSHISTMOV,
           DELETED.IDTIPMOCVLI,
           DELETED.CDFILIAL,
           DELETED.CDCAIXA,
           DELETED.NRSEQVENDA,
           DELETED.DTABERCAIX,
           DELETED.NRSEQUMOVI,
           DELETED.CDTIPORECE,
           DELETED.VRSALDOCONS,
           DELETED.VRMOVPESCONS,
           DELETED.VRSALDPECONS,
           DELETED.CDOPERADOR,
           DELETED.CDOPERECSALD,
           DELETED.DTATUMOVCLIE,
           DELETED.DSATUMOVCLIE,
           DELETED.DTMOVIMCLIE,
           DELETED.DTRECMOVCLIE,
           DELETED.CDFILIAPFATU,
           DELETED.NRAPURACFATU,
           DELETED.VRPESUBSIDIO,
           DELETED.VRTETOSUBSID,
           DELETED.DTULTATUMCLI

     FROM
           INSERTED,
           DELETED
     WHERE     
           INSERTED.CDFILIAL    = DELETED.CDFILIAL AND
           INSERTED.NRSEQMOVCLI = DELETED.NRSEQMOVCLI
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
           INSERTED.CDCLIENTE,
           INSERTED.NRSEQMOVCLI,
           INSERTED.CDCONSUMIDOR,
           INSERTED.VRMOVCLI,
           INSERTED.DTMOVCLI,
           INSERTED.DSHISTMOV,
           INSERTED.IDTIPMOCVLI,
           INSERTED.CDFILIAL,
           INSERTED.CDCAIXA,
           INSERTED.NRSEQVENDA,
           INSERTED.DTABERCAIX,
           INSERTED.NRSEQUMOVI,
           INSERTED.CDTIPORECE,
           INSERTED.VRSALDOCONS,
           INSERTED.VRMOVPESCONS,
           INSERTED.VRSALDPECONS,
           INSERTED.CDOPERADOR,
           INSERTED.CDOPERECSALD,
           INSERTED.DTATUMOVCLIE,
           INSERTED.DSATUMOVCLIE,
           INSERTED.DTMOVIMCLIE,
           INSERTED.DTRECMOVCLIE,
           INSERTED.CDFILIAPFATU,
           INSERTED.NRAPURACFATU,
           INSERTED.VRPESUBSIDIO,
           INSERTED.VRTETOSUBSID,
           INSERTED.DTULTATUMCLI,
           NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL

     FROM
           INSERTED
     WHERE     
           INSERTED.CDFILIAL + INSERTED.NRSEQMOVCLI  NOT IN (SELECT CDFILIAL + NRSEQMOVCLI FROM DELETED)

     OPEN C_CURSOR;
     FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
          			   @V_NEW_CDCLIENTE,@V_NEW_NRSEQMOVCLI,@V_NEW_CDCONSUMIDOR,@V_NEW_VRMOVCLI,
			           @V_NEW_DTMOVCLI,@V_NEW_DSHISTMOV,@V_NEW_IDTIPMOCVLI,@V_NEW_CDFILIAL,
			           @V_NEW_CDCAIXA,@V_NEW_NRSEQVENDA,@V_NEW_DTABERCAIX,@V_NEW_NRSEQUMOVI,
			           @V_NEW_CDTIPORECE,@V_NEW_VRSALDOCONS,@V_NEW_VRMOVPESCONS,@V_NEW_VRSALDPECONS,
			           @V_NEW_CDOPERADOR,@V_NEW_CDOPERECSALD,@V_NEW_DTATUMOVCLIE,@V_NEW_DSATUMOVCLIE,
			           @V_NEW_DTMOVIMCLIE,@V_NEW_DTRECMOVCLIE,@V_NEW_CDFILIAPFATU,@V_NEW_NRAPURACFATU,
			           @V_NEW_VRPESUBSIDIO,@V_NEW_VRTETOSUBSID,@V_NEW_DTULTATUMCLI,


			           @V_OLD_CDCLIENTE,@V_OLD_NRSEQMOVCLI,@V_OLD_CDCONSUMIDOR,@V_OLD_VRMOVCLI,
			           @V_OLD_DTMOVCLI,@V_OLD_DSHISTMOV,@V_OLD_IDTIPMOCVLI,@V_OLD_CDFILIAL,
			           @V_OLD_CDCAIXA,@V_OLD_NRSEQVENDA,@V_OLD_DTABERCAIX,@V_OLD_NRSEQUMOVI,
			           @V_OLD_CDTIPORECE,@V_OLD_VRSALDOCONS,@V_OLD_VRMOVPESCONS,@V_OLD_VRSALDPECONS,
			           @V_OLD_CDOPERADOR,@V_OLD_CDOPERECSALD,@V_OLD_DTATUMOVCLIE,@V_OLD_DSATUMOVCLIE,
			           @V_OLD_DTMOVIMCLIE,@V_OLD_DTRECMOVCLIE,@V_OLD_CDFILIAPFATU,@V_OLD_NRAPURACFATU,
			           @V_OLD_VRPESUBSIDIO,@V_OLD_VRTETOSUBSID,@V_OLD_DTULTATUMCLI

    WHILE (@@FETCH_STATUS = 0) BEGIN
       IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
		IF ISNULL(@V_NEW_CDCLIENTE ,'NULL') <> ISNULL(@V_OLD_CDCLIENTE ,'NULL') BEGIN
          SET @V_DESC  = 'Cliente ' + ISNULL(@V_NEW_CDCLIENTE,'');
        END;
		IF ISNULL(@V_NEW_NRSEQMOVCLI ,'NULL') <> ISNULL(@V_OLD_NRSEQMOVCLI ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Seq Mov Cli ' + ISNULL(@V_NEW_NRSEQMOVCLI,'');
		END;
		IF ISNULL(@V_NEW_CDCONSUMIDOR ,'NULL') <> ISNULL(@V_OLD_CDCONSUMIDOR ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Cons ' + ISNULL(@V_NEW_CDCONSUMIDOR,'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRMOVCLI) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRMOVCLI) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Mov Cli ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMOVCLI),'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTMOVCLI) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTMOVCLI) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Mov Cli ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTMOVCLI),'');
		END;
		IF ISNULL(@V_NEW_DSHISTMOV ,'NULL') <> ISNULL(@V_OLD_DSHISTMOV ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Hist Mov ' + ISNULL(@V_NEW_DSHISTMOV,'');
		END;
		IF ISNULL(@V_NEW_IDTIPMOCVLI ,'NULL') <> ISNULL(@V_OLD_IDTIPMOCVLI ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Tp Mov Cli ' + ISNULL(@V_NEW_IDTIPMOCVLI,'');
		END;
		IF ISNULL(@V_NEW_CDFILIAL ,'NULL') <> ISNULL(@V_OLD_CDFILIAL ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Filial ' + ISNULL(@V_NEW_CDFILIAL,'');
		END;
		IF ISNULL(@V_NEW_CDCAIXA ,'NULL') <> ISNULL(@V_OLD_CDCAIXA ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Caixa ' + ISNULL(@V_NEW_CDCAIXA,'');
		END;
		IF ISNULL(@V_NEW_NRSEQVENDA ,'NULL') <> ISNULL(@V_OLD_NRSEQVENDA ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Nr Seq Venda ' + ISNULL(@V_NEW_NRSEQVENDA,'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTABERCAIX) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTABERCAIX) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Aber Caixa ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTABERCAIX),'');
		END;
		IF ISNULL(@V_NEW_NRSEQUMOVI ,'NULL') <> ISNULL(@V_OLD_NRSEQUMOVI ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Nr Seq Movi ' + ISNULL(@V_NEW_NRSEQUMOVI,'');
		END;
		IF ISNULL(@V_NEW_CDTIPORECE ,'NULL') <> ISNULL(@V_OLD_CDTIPORECE ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Tp Rece ' + ISNULL(@V_NEW_CDTIPORECE,'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRSALDOCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRSALDOCONS) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Saldo Cons ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRSALDOCONS),'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRMOVPESCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRMOVPESCONS) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Mov Pes ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMOVPESCONS),'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRSALDPECONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRSALDPECONS) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Saldo Pes ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRSALDPECONS),'');
		END;
		IF ISNULL(@V_NEW_CDOPERADOR ,'NULL') <> ISNULL(@V_OLD_CDOPERADOR ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Operador ' + ISNULL(@V_NEW_CDOPERADOR,'');
		END;
		IF ISNULL(@V_NEW_CDOPERECSALD ,'NULL') <> ISNULL(@V_OLD_CDOPERECSALD ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Operec Sald ' + ISNULL(@V_NEW_CDOPERECSALD,'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTATUMOVCLIE) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTATUMOVCLIE) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Ult Atu Mov ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTATUMOVCLIE),'');
		END;
		IF ISNULL(@V_NEW_DSATUMOVCLIE ,'NULL') <> ISNULL(@V_OLD_DSATUMOVCLIE ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Ds Atu Mov ' + ISNULL(@V_NEW_DSATUMOVCLIE,'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTMOVIMCLIE) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTMOVIMCLIE) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Mov MCli ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTMOVIMCLIE),'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTRECMOVCLIE) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTRECMOVCLIE) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Rec ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTRECMOVCLIE),'');
		END;
		IF ISNULL(@V_NEW_CDFILIAPFATU ,'NULL') <> ISNULL(@V_OLD_CDFILIAPFATU ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' CDFILIAPFATU ' + ISNULL(@V_NEW_CDFILIAPFATU,'');
		END;
		IF ISNULL(@V_NEW_NRAPURACFATU ,'NULL') <> ISNULL(@V_OLD_NRAPURACFATU ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' NRAPURACFATU ' + ISNULL(@V_NEW_NRAPURACFATU,'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRPESUBSIDIO) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRPESUBSIDIO) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' VRPESUBSIDIO ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRPESUBSIDIO),'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRTETOSUBSID) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRTETOSUBSID) ,'NULL') BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' VRTETOSUBSID ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRTETOSUBSID),'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUMCLI) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTATUMCLI) ,'NULL') BEGIN
		  SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Ult Atu ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUMCLI),'');
		END;
          SET @V_IDTIPOOPER = '2';
       END;
       IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
        IF @V_NEW_CDCLIENTE IS NOT NULL BEGIN
          SET @V_DESC  = 'Cliente ' + ISNULL(@V_NEW_CDCLIENTE,'');
        END;
		IF @V_NEW_NRSEQMOVCLI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Seq Mov Cli ' + ISNULL(@V_NEW_NRSEQMOVCLI,'');
		END;
		IF @V_NEW_CDCONSUMIDOR IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Cons ' + ISNULL(@V_NEW_CDCONSUMIDOR,'');
		END;
		IF @V_NEW_VRMOVCLI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Mov Cli ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMOVCLI),'');
		END;
		IF @V_NEW_DTMOVCLI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Mov Cli ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTMOVCLI),'');
		END;
		IF @V_NEW_DSHISTMOV IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Hist Mov ' + ISNULL(@V_NEW_DSHISTMOV,'');
		END;
		IF @V_NEW_IDTIPMOCVLI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Tp Mov Cli ' + ISNULL(@V_NEW_IDTIPMOCVLI,'');
		END;
		IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Filial ' + ISNULL(@V_NEW_CDFILIAL,'');
		END;
		IF @V_NEW_CDCAIXA IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Caixa ' + ISNULL(@V_NEW_CDCAIXA,''      );
		END;
		IF @V_NEW_NRSEQVENDA IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Nr Seq Venda ' + ISNULL(@V_NEW_NRSEQVENDA,'');
		END;
		IF @V_NEW_DTABERCAIX IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Aber Caixa ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTABERCAIX),'');
		END;
		IF @V_NEW_NRSEQUMOVI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Nr Seq Movi ' + ISNULL(@V_NEW_NRSEQUMOVI,'');
		END;
		IF @V_NEW_CDTIPORECE IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Tp Rece ' + ISNULL(@V_NEW_CDTIPORECE,'');
		END;
		IF @V_NEW_VRSALDOCONS IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Saldo Cons ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRSALDOCONS),'');
		END;
		IF @V_NEW_VRMOVPESCONS IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Mov Pes ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMOVPESCONS),'');
		END;
		IF @V_NEW_VRSALDPECONS IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Saldo Pes ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRSALDPECONS),'');
		END;
		IF @V_NEW_CDOPERADOR IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Operador ' + ISNULL(@V_NEW_CDOPERADOR,'');
		END;
		IF @V_NEW_CDOPERECSALD IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Operec Sald ' + ISNULL(@V_NEW_CDOPERECSALD,'');
		END;
		IF @V_NEW_DTATUMOVCLIE  IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Ult Atu Mov ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTATUMOVCLIE),'');
		END;
		IF @V_NEW_DSATUMOVCLIE IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Ds Atu Mov ' + ISNULL(@V_NEW_DSATUMOVCLIE,'');
		END;
		IF @V_NEW_DTMOVIMCLIE IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Mov MCli ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTMOVIMCLIE),'');
		END;
		IF @V_NEW_DTRECMOVCLIE IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Rec ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTRECMOVCLIE),'');
		END;
		IF @V_NEW_CDFILIAPFATU IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' CDFILIAPFATU ' + ISNULL(@V_NEW_CDFILIAPFATU,'');
		END;
		IF @V_NEW_NRAPURACFATU IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' NRAPURACFATU ' + ISNULL(@V_NEW_NRAPURACFATU,'');
		END;
		IF @V_NEW_VRPESUBSIDIO IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' VRPESUBSIDIO ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRPESUBSIDIO),'');
		END;
		IF @V_NEW_VRTETOSUBSID IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' VRTETOSUBSID ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRTETOSUBSID),'');
		END;
		IF @V_NEW_DTULTATUMCLI IS NOT NULL BEGIN
		  SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Ult Atu ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUMCLI),'');
		END;
		SET @V_IDTIPOOPER = '1';
       END;
       IF @V_ID_COMANDO= 'D' /*DELEO*/  BEGIN
        IF @V_OLD_CDCLIENTE IS NOT NULL BEGIN
          SET @V_DESC  = 'Cliente ' + ISNULL(@V_OLD_CDCLIENTE,'');
        END;
		IF @V_OLD_NRSEQMOVCLI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Seq Mov Cli ' + ISNULL(@V_OLD_NRSEQMOVCLI,'');
		END;
		IF @V_OLD_CDCONSUMIDOR IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Cons ' + ISNULL(@V_OLD_CDCONSUMIDOR,'');
		END;
		IF @V_OLD_VRMOVCLI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Mov Cli ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRMOVCLI),'');
		END;
		IF @V_OLD_DTMOVCLI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Mov Cli ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTMOVCLI),'');
		END;
		IF @V_OLD_DSHISTMOV IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Hist Mov ' + ISNULL(@V_OLD_DSHISTMOV,'');
		END;
		IF @V_OLD_IDTIPMOCVLI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Tp Mov Cli ' + ISNULL(@V_OLD_IDTIPMOCVLI,'');
		END;
		IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Filial ' + ISNULL(@V_OLD_CDFILIAL,'');
		END;
		IF @V_OLD_CDCAIXA IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Caixa ' + ISNULL(@V_OLD_CDCAIXA,''      );
		END;
		IF @V_OLD_NRSEQVENDA IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Nr Seq Venda ' + ISNULL(@V_OLD_NRSEQVENDA,'');
		END;
		IF @V_OLD_DTABERCAIX IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Aber Caixa ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTABERCAIX),'');
		END;
		IF @V_OLD_NRSEQUMOVI IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Nr Seq Movi ' + ISNULL(@V_OLD_NRSEQUMOVI,'');
		END;
		IF @V_OLD_CDTIPORECE IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Tp Rece ' + ISNULL(@V_OLD_CDTIPORECE,'');
		END;
		IF @V_OLD_VRSALDOCONS IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Saldo Cons ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRSALDOCONS),'');
		END;
		IF @V_OLD_VRMOVPESCONS IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Mov Pes ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRMOVPESCONS),'');
		END;
		IF @V_OLD_VRSALDPECONS IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Vr Saldo Pes ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRSALDPECONS),'');
		END;
		IF @V_OLD_CDOPERADOR IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Operador ' + ISNULL(@V_OLD_CDOPERADOR,'');
		END;
		IF @V_OLD_CDOPERECSALD IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Cd Operec Sald ' + ISNULL(@V_OLD_CDOPERECSALD,'');
		END;
		IF @V_OLD_DTATUMOVCLIE  IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Ult Atu Mov ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTATUMOVCLIE),'');
		END;
		IF @V_OLD_DSATUMOVCLIE IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Ds Atu Mov ' + ISNULL(@V_OLD_DSATUMOVCLIE,'');
		END;
		IF @V_OLD_DTMOVIMCLIE IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Mov MCli ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTMOVIMCLIE),'');
		END;
		IF @V_OLD_DTRECMOVCLIE IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Rec ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTRECMOVCLIE),'');
		END;
		IF @V_OLD_CDFILIAPFATU IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' CDFILIAPFATU ' + ISNULL(@V_OLD_CDFILIAPFATU,'');
		END;
		IF @V_OLD_NRAPURACFATU IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' NRAPURACFATU ' + ISNULL(@V_OLD_NRAPURACFATU,'');
		END;
		IF @V_OLD_VRPESUBSIDIO IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' VRPESUBSIDIO ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRPESUBSIDIO),'');
		END;
		IF @V_OLD_VRTETOSUBSID IS NOT NULL BEGIN
          SET @V_DESC  = ISNULL(@V_DESC,'')+ ' VRTETOSUBSID ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRTETOSUBSID),'');
		END;
		IF @V_OLD_DTULTATUMCLI IS NOT NULL BEGIN
		  SET @V_DESC  = ISNULL(@V_DESC,'')+ ' Dt Ult Atu ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTATUMCLI),'');
		END;
          SET @V_IDTIPOOPER = '3';
       END;
       IF  (@V_IDTIPOOPER <> '') BEGIN
          IF @V_DESC IS NOT NULL BEGIN
             SET @V_ITPESQ =  ISNULL( @V_NEW_CDFILIAL + @V_NEW_NRSEQMOVCLI , @V_OLD_CDFILIAL + @V_OLD_NRSEQMOVCLI );
             SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
             INSERT INTO LOGOPERAVND
                    (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                     CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                     CDORESPOPERVND, CDFILLOGOPERVND)
             VALUES ('MOVICLIE',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                     @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER,
                     ISNULL(@V_NEW_CDFILIAL,@V_OLD_CDFILIAL));
          END;
       END;
       FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
          			     @V_NEW_CDCLIENTE,@V_NEW_NRSEQMOVCLI,@V_NEW_CDCONSUMIDOR,@V_NEW_VRMOVCLI,
			             @V_NEW_DTMOVCLI,@V_NEW_DSHISTMOV,@V_NEW_IDTIPMOCVLI,@V_NEW_CDFILIAL,
			             @V_NEW_CDCAIXA,@V_NEW_NRSEQVENDA,@V_NEW_DTABERCAIX,@V_NEW_NRSEQUMOVI,
			             @V_NEW_CDTIPORECE,@V_NEW_VRSALDOCONS,@V_NEW_VRMOVPESCONS,@V_NEW_VRSALDPECONS,
			             @V_NEW_CDOPERADOR,@V_NEW_CDOPERECSALD,@V_NEW_DTATUMOVCLIE,@V_NEW_DSATUMOVCLIE,
			             @V_NEW_DTMOVIMCLIE,@V_NEW_DTRECMOVCLIE,@V_NEW_CDFILIAPFATU,@V_NEW_NRAPURACFATU,
			             @V_NEW_VRPESUBSIDIO,@V_NEW_VRTETOSUBSID,@V_NEW_DTULTATUMCLI,

			             @V_OLD_CDCLIENTE,@V_OLD_NRSEQMOVCLI,@V_OLD_CDCONSUMIDOR,@V_OLD_VRMOVCLI,
			             @V_OLD_DTMOVCLI,@V_OLD_DSHISTMOV,@V_OLD_IDTIPMOCVLI,@V_OLD_CDFILIAL,
			             @V_OLD_CDCAIXA,@V_OLD_NRSEQVENDA,@V_OLD_DTABERCAIX,@V_OLD_NRSEQUMOVI,
			             @V_OLD_CDTIPORECE,@V_OLD_VRSALDOCONS,@V_OLD_VRMOVPESCONS,@V_OLD_VRSALDPECONS,
			             @V_OLD_CDOPERADOR,@V_OLD_CDOPERECSALD,@V_OLD_DTATUMOVCLIE,@V_OLD_DSATUMOVCLIE,
			             @V_OLD_DTMOVIMCLIE,@V_OLD_DTRECMOVCLIE,@V_OLD_CDFILIAPFATU,@V_OLD_NRAPURACFATU,
			             @V_OLD_VRPESUBSIDIO,@V_OLD_VRTETOSUBSID,@V_OLD_DTULTATUMCLI
    SET @V_DESC   = '';
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_MOVICLIE','5.20.001';
GO 
