<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaVincevento extends \Doctrine\ORM\EntityRepository {
    
    public function retornaAssociacoesVinculoEvento($nrOrg, $nrVinculo, $mesCompetencia){
        $params = array(
            'p_dtmescompetenc' => $mesCompetencia,
            'p_nrorg' => $nrOrg,
            'p_nrvinculom' => $nrVinculo
        );
        $fpa_vincevento = Repositories::FPA_VINCEVENTO;
$sql = <<<SQL
             SELECT ve
              FROM $fpa_vincevento ve
              WHERE ve.dtinivigencia = 
                 (
                  SELECT MAX(vee.dtinivigencia)
                  FROM $fpa_vincevento vee
                  WHERE vee.nrorg = :p_nrorg
                  AND vee.nrvinculom = :p_nrvinculom
                  AND vee.dtinivigencia <= :p_dtmescompetenc
                  AND ve.nreventom = vee.nreventom
                  )
              AND ve.nrorg = :p_nrorg
              AND ve.nrvinculom = :p_nrvinculom
SQL;
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }
}